$DEBUG
	IMPLICIT REAL*8 (A-H, O-Z)
	DIMENSION A(40,40), H(40,40),TETA(40),WR(40),WI(40)
	DIMENSION NN(7)
	DATA NN/2,3,4,5,10,20,40/
	OPEN(1,FILE='PAU.DAT',STATUS='NEW')
	WRITE(*,10)
   10	FORMAT(1X,'UNETI LAMBDA U FORMATU D6.1'/)
	READ(*,20) ALAM
   20	FORMAT(D6.1)
	NM = 40
	DO 5 I = 1, NM
	DO 5 J = 1, NM
    5	A(I,J) = 0
	CALL QK(NM, TETA0, TETA, ALAM)
	A(1,1) = TETA0
	A(1,2) = TETA0
	A(2,1) = -A(1,2)
	A(2,2) = TETA(1) - TETA0
	DO 15 K = 3, NM
	A(K,K) = TETA(K-1) - TETA(K-2)
	A(K-1,K) = TETA(K-2)
   15	A(K,K-1) = -A(K-1,K)
	DO 11 KK = 1, 6
	N = NN(KK)
	DO 22 I = 1,N
	DO 22 J = 1,N
   22	H(I,J) = A(I,J)
C
	CALL HQR(NM, N, 1, N, H, WR, WI, IERR)
	WRITE(*,30) IERR
   30	FORMAT (1X, 'IERR = ',I3)
	WRITE(1,40) N, ALAM
   40	FORMAT(5X,'N=',I4,2X,'ALAM=',F4.1/)
	DO 33 K=1,N
	AA = -WI(K)
	BMOD = DSQRT(WI(K)*WI(K) + WR(K)*WR(K))
   33	WRITE(1,50)K,AA,WR(K),BMOD
   50	FORMAT (5X,I3,3X,2(F20.16,3X),F7.4)
   11   CONTINUE
	CLOSE (1)
	STOP
	END
	SUBROUTINE QK (NM, TETA0, TETA, ALAM)
	IMPLICIT REAL*8 (A-H, O-Z)
	DIMENSION TETA(1)
	PI = 3.14159265358979323846D0
	IF (ALAM.EQ.0) THEN
	TETA0 = 1
	DO 5 K = 1, NM
    5	TETA(K) = 0.5D0
	RETURN
	ELSE
	ENDIF
	IF (ALAM.EQ.1) THEN
	TETA0 = 0.5D0
	DO 6 K = 1, NM
    6	TETA(K) = TETA0
	RETURN
	ELSE
	ENDIF
	TETA0 = 2.D0/PI
	U = TETA0
	DO 10 K = 1, NM
	V = K * (K+2*ALAM-1)
	V = V / 4 /(K+ALAM)/(K+ALAM-1)
	TETA(K) = V/U
   10	U = TETA(K)
	RETURN
	END
