$DEBUG
	IMPLICIT REAL*8 (A-H, O-Z)
	DIMENSION A(20,20), H(20,20),TETA(40),WR(40),WI(40)
	DIMENSION NN(7),Z(20,20),IPVT(20)
        COMPLEX*16 V(20,20),B(20)
	DATA NN/2,3,4,5,10,20,40/
C	OPEN(1,FILE='PAU.DAT',STATUS='NEW')
	WRITE(*,10)
   10	FORMAT(1X,'UNETI LAMBDA U FORMATU D6.1'/)
	READ(*,20) ALAM
   20	FORMAT(D6.1)
	NM = 20
	DO 5 I = 1, NM
	DO 5 J = 1, NM
    5	A(I,J) = 0
	CALL QK(NM, TETA0, TETA, ALAM)
	A(1,1) = TETA0
	A(1,2) = TETA0
	A(2,1) = -A(1,2)
	A(2,2) = TETA(1) - TETA0
	DO 15 K = 3, NM
	A(K,K) = TETA(K-1) - TETA(K-2)
	A(K-1,K) = TETA(K-2)
   15	A(K,K-1) = -A(K-1,K)
	DO 11 KK = 1, 6
	N = NN(KK)
	DO 22 I = 1,N
	DO 22 J = 1,N
        Z(I,J) = 0
   22	H(I,J) = A(I,J)
   	DO 23 I = 1, N
   23	Z(I,I) = 1
C
	CALL HQR2(NM, N, 1, N, H, WR, WI,Z, IERR)
	WRITE(1,30) IERR
   30	FORMAT (1X, 'IERR = ',I3)
	WRITE(1,40) N, ALAM
   40	FORMAT(5X,'N=',I4,2X,'ALAM=',F4.1/)
	DO 33 K=1,N
	AA = -WI(K)
	BMOD = DSQRT(WI(K)*WI(K) + WR(K)*WR(K))
   33	WRITE(1,50)K,AA,WR(K),BMOD
   50	FORMAT (5X,I3,3X,2(F20.16,3X),F7.4)
   	DO 51 J=1,N
        IF(WI(J).EQ.0) THEN
           DO 52 I=1,N
   52      V(I,J) = Z(I,J)
   	GO TO 51
   	ENDIF
        IF(WI(J).GT.0) THEN
          DO 53 I=1,N
          V(I,J)=Z(I,J)+(0.D0,1.D0)*Z(I,J+1)
   53     V(I,J+1)=Z(I,J)-(0.D0,1.D0)*Z(I,J+1)
   	ENDIF
   51	CONTINUE
C  	DO 61 J=1,N
C  61   WRITE(1,60)(V(I,J),I=1,N)
C  60	FORMAT(10F8.3)
   	DO 71 J=1,N
        DO 72 I=2,N
   72	V(I,J)=V(I,J)/V(1,J)
   71	V(1,J)=1
C  	DO 81 J=1,N
C  81   WRITE(1,60)(V(I,J),I=1,N)
C	CLOSE(1)
	CALL ZGEFA(V, NM, N, IPVT, INFO)
        WRITE(1,70) INFO
  70	FORMAT(1X,'INFO-ZGEFA-: ',I3)
  	B(1) = 3.14159265358979323846D0
        DO 222 JK=2,N
  222	B(JK) = 0
  	CALL ZGESL(V, NM, N, IPVT, B, 0)
        WRITE(1,711)(B(JK),JK=1,N)
  711	FORMAT(2F26.16)
   11	CONTINUE
	STOP
	END
	SUBROUTINE QK (NM, TETA0, TETA, ALAM)
	IMPLICIT REAL*8 (A-H, O-Z)
	DIMENSION TETA(1)
	PI = 3.14159265358979323846D0
	IF (ALAM.EQ.0) THEN
	TETA0 = 1
	DO 5 K = 1, NM
    5	TETA(K) = 0.5D0
	RETURN
	ELSE
	ENDIF
	IF (ALAM.EQ.1) THEN
	TETA0 = 0.5D0
	DO 6 K = 1, NM
    6	TETA(K) = TETA0
	RETURN
	ELSE
	ENDIF
	TETA0 = 2.D0/PI
	U = TETA0
	DO 10 K = 1, NM
	V = K * (K+2*ALAM-1)
	V = V / 4 /(K+ALAM)/(K+ALAM-1)
	TETA(K) = V/U
   10	U = TETA(K)
	RETURN
	END
