	SUBROUTINE ZAXPY (N,ZA,ZX,INCX,ZY,INCY)
C
C	CONSTANT TIMES A VECTOR PLUS A VECTOR
C
	COMPLEX*16 ZX(1), ZY(1), ZA
        INTEGER I,INCX,INCY,IX,IY,M,MP1,N
C
	IF(N.LE.0) RETURN
        IF(CABS(ZA) .EQ. 0.D0) RETURN
        IF(INCX.EQ.1 .AND. INCY .EQ. 1) GO TO 20
C
C     CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C	NOT EQUAL TO 1
C
	IX = 1
        IY = 1
        IF(INCX.LT.0) IX = (-N+1)*INCX + 1
        IF(INCY.LT.0) IY = (-N+1)*INCY + 1
        DO 10 I = 1, N
          ZY(IY) = ZY(IY) + ZA*ZX(IX)
          IX = IX + INCX
          IY = IY + INCY
   10	CONTINUE
   	RETURN
C
C   CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C   CLEAN-UP LOOP
C
   20	M = MOD(N,4)
   	IF(M .EQ. 0) GO TO 40
        DO 30 I=1,M
          ZY(I) = ZY(I) + ZA * ZX(I)
   30	CONTINUE
   	IF( N .LT. 4) RETURN
   40	MP1 = M + 1
   	DO 50 I = MP1,N,4
          ZY(I) = ZY(I) + ZA * ZX(I)
          ZY(I+1) = ZY(I+1) + ZA * ZX(I+1)
          ZY(I+2) = ZY(I+2) + ZA * ZX(I+2)
          ZY(I+3) = ZY(I+3) + ZA * ZX(I+3)
   50	CONTINUE
   	RETURN
        END
