	COMPLEX*16 FUNCTION ZDOTU(N,ZX,INCX,ZY,INCY)
C
C   FORMS THE DOT PRODUCT OF TWO (COMPLEX*16) VECTORS
C
	COMPLEX*16 ZX(1),ZY(1),ZTEMP
        INTEGER I,INCX,INCY,IX,IY,M,MP1,N
C
	ZTEMP=(0.D0, 0.D0)
        ZDOTU =(0.D0, 0.D0)
        IF(N.LE.0) RETURN
        IF(INCX.EQ.1 .AND. INCY.EQ.1) GO TO 20
C
C   CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C   NOT EQUAL TO 1
C
	IX = 1
        IY = 1
        IF(INCX.LT.0) IX = (-N+1) * INCX + 1
        IF(INCY.LT.0) IY = (-N+1) * INCY + 1
        DO 10 I = 1, N
          ZTEMP = ZTEMP + ZX(IX) * ZY(IY)
          IX = IX + INCX
          IY = IY + INCY
   10	CONTINUE
   	ZDOTU = ZTEMP
        RETURN
C
C     CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C     CLEAN-UP LOOP
C
   20	M = MOD(N, 5)
   	IF( M .EQ. 0) GO TO 40
        DO 30 I=1, M
          ZTEMP = ZTEMP +  ZX(I) * ZY(I)
   30	CONTINUE
   	IF( N .LT. 5) GO TO 60
   40	MP1 = M + 1
   	DO 50 I = MP1,N,5
          ZTEMP = ZTEMP + ZX(I)*ZY(I) + ZX(I+1)*ZY(I+1) +
     *	  ZX(I+2)*ZY(I+2) + ZX(I+3)*ZY(I+3) + ZX(I+4)*ZY(I+4)
   50	CONTINUE
   60	ZDOTU = ZTEMP
   	RETURN
        END
